#ifndef PORTABLE_NEW_INCLUDED
#define PORTABLE_NEW_INCLUDED



//
// Copyright 2002, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.

///@file portable_new.h
/// 
///  Defines a list of portable 'new' style memory allocators.  Deals with
///  older compilers that don't have exceptions in the new header file.
///  Add any additional functions that are needed for portability here.


#include <new>

#ifdef NEW_NO_EXCEPTIONS
  // specifically the older compilers that don't have an exception
  // specification on operator new
  #define THROW(x)
  #define BAD_ALLOC_EXCEPTION
  #define THROW_NOTHING
#else
  #define  THROW(x)           throw(x)
  #define  THROW_NOTHING      throw()
  #define BAD_ALLOC_EXCEPTION std::bad_alloc
#endif

#endif
